package ij.example.dvdshop;

import ij.util.XMLUtil;

public class DVD {                                            
  protected String code;
  public String getCode(){ return code; }
  public void setCode(String code){ this.code=code; }

  protected String title;
  public String getTitle(){ return title; }
  public void setTitle(String title){ this.title=title; }

  protected int releaseDate;                                  
  public int getReleaseDate(){ return releaseDate; }
  public void setReleaseDate(int releaseDate){  
    this.releaseDate=releaseDate; 
  }

  protected String director;
  public String getDirector(){ return director; }
  public void setDirector(String director){ this.director=director; }

  protected String actors;
  public String getActors(){ return actors; }
  public void setActors(String actors){ this.actors=actors; }

  protected boolean borrowed;
  public boolean isBorrowed(){ return borrowed; }              
  public void setBorrowed(boolean borrowed){ this.borrowed=borrowed; }

  protected double price;                                  
  public double getPrice(){ return price; }
  public void setPrice(double price){ this.price = price; }
  
  public boolean isForSale(){ return price!=0; }
  
  public DVD(){ }

  public DVD(String code, String title, int releaseDate, 
                                         String director, String actors){ 
    this.code=code;
    this.title=title; this.releaseDate=releaseDate;
    this.director=director; this.actors=actors;
  }

  public StringBuilder appendXML(StringBuilder b, String ident){     
    String inner=ident+"  ";
    b.append(ident).append("<DVD>\n");
    XMLUtil.appendXML(b,inner,"code", getCode());
    XMLUtil.appendXML(b,inner,"title", getTitle());
    XMLUtil.appendXML(b,inner,"releaseDate", getReleaseDate());
    XMLUtil.appendXML(b,inner,"director", getDirector());
    XMLUtil.appendXML(b,inner,"actors", getActors());
    b.append(ident).append("</DVD>\n");
    return b;
  }    
  public String toXML(){
    StringBuilder b=new StringBuilder();
    b.append("<?xml version=\"1.0\" encoding=\"iso-8859-2\"?>\n");
    return appendXML(b,"").toString();
  }
  
  public static DVD fromXML(String xml){ 
    DVD dvd=new DVD();
    dvd.setCode(XMLUtil.fromXML(xml,"code"));
    dvd.setTitle(XMLUtil.fromXML(xml,"title"));
 // dvd.setReleaseDate(XMLUtil.fromXML(xml,"releaseDate"));  
    dvd.setDirector(XMLUtil.fromXML(xml,"director"));
    dvd.setActors(XMLUtil.fromXML(xml,"actors"));
    return dvd;
  }
  
  
  public static void main(String args[]){
    DVD dvdx=new DVD("1001", "Nights on Java", 2006, "Ben Boss",
                    "Dev E. Lopez, T. Esther Works"
    );    
    DVD dvd=DVD.fromXML("<DVD>"
      +"<code>1001</code>"
      +"<title>Nights on Java</title>"
      +"<releaseDate>2006</releaseDate>"
      +"<director>Ben Boss</director>"
      +"<actors>Dev E. Lopez, T. Esther Works</actors>"
      +"</DVD>"
    );
    System.out.println(dvd.toXML());
  }
}
