package ij.example.dvdshop;

import ij.util.*;

import java.util.*;

public class DVD implements XMLFragment{    
  protected static final Set<String> FIELD_NAMES= new ArrayListSet( 
      "code", "title", "releaseDate", "director", "actors" 
  );
  public Set<String> keySet(){ return FIELD_NAMES; }

  protected String code;
  public String getCode(){ return code; }
  public void setCode(String code){ this.code=code; }

  protected String title;
  public String getTitle(){ return title; }
  public void setTitle(String title){ this.title=title; }

  protected int releaseDate;                                  
  public int getReleaseDate(){ return releaseDate; }
  public void setReleaseDate(int releaseDate){  
    this.releaseDate=releaseDate; 
  }

  protected String director;
  public String getDirector(){ return director; }
  public void setDirector(String director){ this.director=director; }

  protected String actors;
  public String getActors(){ return actors; }
  public void setActors(String actors){ this.actors=actors; }

  protected boolean borrowed;
  public boolean isBorrowed(){ return borrowed; }              
  public void setBorrowed(boolean borrowed){ this.borrowed=borrowed; }

  protected double price;                                  
  public double getPrice(){ return price; }
  public void setPrice(double price){ this.price = price; }
  
  public boolean isForSale(){ return price!=0; }
  
  public DVD(){ }

  public DVD(String code, String title, int releaseDate, 
                                         String director, String actors){ 
    this.code=code;
    this.title=title; this.releaseDate=releaseDate;
    this.director=director; this.actors=actors;
  }  

  public String appendXMLHead(StringBuilder b, String ident){
    b.append(ident).append("<DVD>\n");
    return "DVD";
  }    
  public XMLFragment[] appendXMLBody(StringBuilder b, String ident){     
    XMLUtil.appendXML(b,ident,toMap()); 
    return null;
  }  
  
  public static DVD fromXML(String xml){ 
    DVD dvd=new DVD();
    dvd.setCode(XMLUtil.fromXML(xml,"code"));
    dvd.setTitle(XMLUtil.fromXML(xml,"title"));
 // dvd.setReleaseDate(XMLUtil.fromXML(xml,"releaseDate"));  
    dvd.setDirector(XMLUtil.fromXML(xml,"director"));
    dvd.setActors(XMLUtil.fromXML(xml,"actors"));
    return dvd;
  }
  
  public Object get(Object key){
    if("code".equals(key)){ return getCode();
    }else if("title".equals(key)){ return getTitle();
    }else if("releaseDate".equals(key)){ return getReleaseDate();
    }else if("director".equals(key)){ return getDirector();
    }else if("actors".equals(key)){ return getActors();
    }
    return null;
  }
  public Map toMap(){ Map map=new LinkedHashMap();
   for(String s: keySet()){
     map.put(s, get(s));
   }
   return map;
  }
  public Object put(Object key, Object value){ 
    if("code".equals(key)){ 
      setCode(ValueUtil.toString(value));
    }else if("title".equals(key)){ 
      setTitle(ValueUtil.toString(value));
    }else if("releaseDate".equals(key)){ 
      setReleaseDate(ValueUtil.toInt(value));    
    }else if("director".equals(key)){ 
      setDirector(ValueUtil.toString(value));
    }else if("actors".equals(key)){ 
      setActors(ValueUtil.toString(value));
    }
    return null;
  }
  public void putAll(Map<? extends Object,? extends Object> map){ 
    for(Map.Entry e: map.entrySet()){
      put(e.getKey(),e.getValue());
    }
  }

  
  public String toString(){ 
    return StringUtil.toString(
      "${title} ( ${releaseDate}; ${director}, ${actors} )",
      toMap()
    ); 
  } 
  
  public static void main(String args[]){
    DVD dvdx=new DVD("1001", "Nights on Java", 2006, "Ben Boss",
                    "Dev E. Lopez, T. Esther Works"
    );    
    DVD dvd=DVD.fromXML("<DVD>"
      +"<code>1001</code>"
      +"<title>Nights on Java</title>"
      +"<releaseDate>2006</releaseDate>"
      +"<director>Ben Boss</director>"
      +"<actors>Dev E. Lopez, T. Esther Works</actors>"
      +"</DVD>"
    );
    System.out.println(XMLBuilder.toXML(dvd));
    
    Map map=new HashMap();
    map.put("code", "9077");
    map.put("price", 1500);
    dvd.putAll(map);
    System.out.println(XMLBuilder.toXML(dvd));
  }
}
