package ij.example.dvdshop;

import ij.util.*;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.util.*;

@PropertyNames({"code", "title", "releaseDate"})
public class DVD extends AbstractKeyBasedMap<String,Object> implements XMLFragment{    
  /*protected static final Set<String> FIELD_NAMES= new ArrayListSet( 
      "code", "title", "releaseDate", "director", "actors" 
  );*/
  protected Set<String> keySet;
  public Set<String> keySet(){
    if(keySet==null){ 
      PropertyNames propertyNames =        
          ((PropertyNames)getClass().getAnnotation(PropertyNames.class));      
      if(propertyNames!=null){
        keySet=new ArrayListSet<String>( propertyNames.value() );
      }else{
        keySet=ReflectionUtil.getProperties(getClass());
      }
    }
    return keySet;   
  }

  protected String code;
  public String getCode(){ return code; }
  public void setCode(String code){ this.code=code; }

  protected String title;
  public String getTitle(){ return title; }
  public void setTitle(String title){ this.title=title; }

  protected int releaseDate;                                  
  public int getReleaseDate(){ return releaseDate; }
  public void setReleaseDate(int releaseDate){  
    this.releaseDate=releaseDate; 
  }

  protected String director;
  public String getDirector(){ return director; }
  public void setDirector(String director){ this.director=director; }

  protected String actors;
  public String getActors(){ return actors; }
  public void setActors(String actors){ this.actors=actors; }

  protected boolean borrowed;
  public boolean isBorrowed(){ return borrowed; }              
  public void setBorrowed(boolean borrowed){ this.borrowed=borrowed; }

  protected double price;                                  
  public double getPrice(){ return price; }
  public void setPrice(double price){ this.price = price; }
  
  public boolean isForSale(){ return price!=0; }
  
  public DVD(){ }

  public DVD(String code, String title, int releaseDate, 
                                         String director, String actors){ 
    this.code=code;
    this.title=title; this.releaseDate=releaseDate;
    this.director=director; this.actors=actors;
  }  

  public String appendXMLHead(Appendable b, String ident) throws IOException{
    b.append(ident).append("<DVD>\n");
    return "DVD";
  }    
  public XMLFragment[] appendXMLBody(Appendable b, String ident) throws IOException{     
    XMLUtil.appendXML(b,ident,toMap()); 
    return null;
  }  
  
  public static DVD fromXML(String xml){ 
    DVD dvd=new DVD();
    dvd.setCode(XMLUtil.fromXML(xml,"code"));
    dvd.setTitle(XMLUtil.fromXML(xml,"title"));
 // dvd.setReleaseDate(XMLUtil.fromXML(xml,"releaseDate"));  
    dvd.setDirector(XMLUtil.fromXML(xml,"director"));
    dvd.setActors(XMLUtil.fromXML(xml,"actors"));
    return dvd;
  }
  
  public Object get(Object key){
    return ReflectionUtil.get(this, key.toString());
  }

  public Map<String,Object> toMap(){ Map map=new LinkedHashMap();
   for(String s: keySet()){
     map.put(s, get(s));
   }
   return map;
  }
  public Object put(String key, Object value){ 
    return ReflectionUtil.put(this, key, value);
  }
  
  public String _toString(){ 
    return StringUtil.toString(
      "${title} ( ${releaseDate}; ${director}, ${actors} )",
      toMap()
    ); 
  } 
  
  public static void main(String args[]){
    /*
    DVD dvdx=new DVD("1001", "Nights on Java", 2006, "Ben Boss",
                    "Dev E. Lopez, T. Esther Works"
    );    
    DVD dvd=DVD.fromXML("<DVD>"
      +"<code>1001</code>"
      +"<title>Nights on Java</title>"
      +"<releaseDate>2006</releaseDate>"
      +"<director>Ben Boss</director>"
      +"<actors>Dev E. Lopez, T. Esther Works</actors>"
      +"</DVD>"
    );
    System.out.println(XMLBuilder.toXML(dvd));*/
    
    /*
    Map map=new HashMap();
    map.put("code", "9077");
    map.put("price", 1500);
    dvd.putAll(map);
    System.out.println(XMLBuilder.toXML(dvd));

    System.out.println(dvd);*/
    
    DVD dvd2=new DVD(); 
    dvd2.putAll( new ArrayMap(
      "code", "2121",
      "title", "Paycheck",
      "releaseDate", 2003,   
      "director", "John Woo",
      "actors", "Ben Affleck, Uma Thurman"
    ));
    System.out.println(dvd2);
    
  }
}
