package ij.example.dvdshop;

import ij.util.*;

import java.util.LinkedHashMap;
import java.util.Map;

public class DVD implements XMLFragment{    
  protected String code;
  public String getCode(){ return code; }
  public void setCode(String code){ this.code=code; }

  protected String title;
  public String getTitle(){ return title; }
  public void setTitle(String title){ this.title=title; }

  protected int releaseDate;                                  
  public int getReleaseDate(){ return releaseDate; }
  public void setReleaseDate(int releaseDate){  
    this.releaseDate=releaseDate; 
  }

  protected String director;
  public String getDirector(){ return director; }
  public void setDirector(String director){ this.director=director; }

  protected String actors;
  public String getActors(){ return actors; }
  public void setActors(String actors){ this.actors=actors; }

  protected boolean borrowed;
  public boolean isBorrowed(){ return borrowed; }              
  public void setBorrowed(boolean borrowed){ this.borrowed=borrowed; }

  protected double price;                                  
  public double getPrice(){ return price; }
  public void setPrice(double price){ this.price = price; }
  
  public boolean isForSale(){ return price!=0; }
  
  public DVD(){ }

  public DVD(String code, String title, int releaseDate, 
                                         String director, String actors){ 
    this.code=code;
    this.title=title; this.releaseDate=releaseDate;
    this.director=director; this.actors=actors;
  }  

  public String appendXMLHead(StringBuilder b, String ident){
    b.append(ident).append("<DVD>\n");
    return "DVD";
  }    
  public XMLFragment[] appendXMLBody(StringBuilder b, String ident){     
    XMLUtil.appendXML(b,ident,"code", getCode());
    XMLUtil.appendXML(b,ident,"title", getTitle());
    XMLUtil.appendXML(b,ident,"releaseDate", getReleaseDate());
    XMLUtil.appendXML(b,ident,"director", getDirector());
    XMLUtil.appendXML(b,ident,"actors", getActors());
    return null;
  }  
  
  public static DVD fromXML(String xml){ 
    DVD dvd=new DVD();
    dvd.setCode(XMLUtil.fromXML(xml,"code"));
    dvd.setTitle(XMLUtil.fromXML(xml,"title"));
 // dvd.setReleaseDate(XMLUtil.fromXML(xml,"releaseDate"));  
    dvd.setDirector(XMLUtil.fromXML(xml,"director"));
    dvd.setActors(XMLUtil.fromXML(xml,"actors"));
    return dvd;
  }
  
  public Map toMap(){ Map map=new LinkedHashMap();
    map.put("code", getCode());
    map.put("title",getTitle());
    map.put("releaseDate",getReleaseDate());
    map.put("director",getDirector());
    map.put("actors",getActors());
    return map;
  }
  
  public String toString(){ return toMap().toString(); } 
  
  public static void main(String args[]){
    DVD dvdx=new DVD("1001", "Nights on Java", 2006, "Ben Boss",
                    "Dev E. Lopez, T. Esther Works"
    );    
    DVD dvd=DVD.fromXML("<DVD>"
      +"<code>1001</code>"
      +"<title>Nights on Java</title>"
      +"<releaseDate>2006</releaseDate>"
      +"<director>Ben Boss</director>"
      +"<actors>Dev E. Lopez, T. Esther Works</actors>"
      +"</DVD>"
    );
    System.out.println(XMLBuilder.toXML(dvd));
  }
}
