package ij.example.dvdshop;

import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;

import org.xml.sax.*;

public class DVDXMLReader extends ij.util.XMLReader<DVDShop>{
  public DVDXMLReader(DVDShop shop){ super(shop); }
  public DVDXMLReader(){ this(new DVDShop()); }
  
  protected DVD dvd;
  public void start(CharSequence path, String name, Attributes attributes) 
                                                     throws SAXException{
    if("DVD".equals(name)){
      dvd=new DVD();
    }
  }
  public void set(CharSequence path, String name, CharSequence value) throws SAXException{
    if(dvd.containsKey(name)){
      dvd.put(name,value);
    }
  }
  public void end(CharSequence path, String name) throws SAXException{
    if("DVD".equals(name)){
      result.add( dvd );    
    }
  }

  public static void main(String args[])
          throws SAXException, ParserConfigurationException, IOException{
    DVDShop shop=new DVDXMLReader().parse("dvd.xml");
    System.out.println(shop.getDVDs());
  }
}
