package ij.example.forsale;

import java.sql.*;
import java.util.ArrayList;
import java.util.List;

public class Category implements java.io.Serializable{
  protected String name;
  public String getName(){ return name; }
  public void setName(String name){ this.name=name; }
  protected String text;
  public String getText(){ return text; }
  public void setText(String text){ this.text=text; }
  public String toString(){ return "Category("+name+": "+text+")"; }
  
  public static void insert(Connection conn, Category category) throws SQLException {
    PreparedStatement stmt=null; 
    try{ 
      stmt=conn.prepareStatement(
        "INSERT INTO category (name,text) VALUES (?,?)"
      );
      stmt.setString(1,category.getName());
      stmt.setString(2,category.getText());
      stmt.executeUpdate();
    }finally{
      try{ stmt.close(); }catch(Exception e){ }
    }
  }
  
  public static void main(String args[]) throws ClassNotFoundException, SQLException{
    Class.forName("org.apache.derby.jdbc.EmbeddedDriver");
    Connection conn=DriverManager.getConnection(
      "jdbc:derby:forsale_db;create=true", "forsale", "passw"
    );
    Category newCategory=new Category();
    newCategory.setName("travel");
    newCategory.setText("Utazs, nyarals, pihens");
    Category.insert(conn,newCategory);    
    
    List<Category> list=new ArrayList<Category>();
    Statement stmt=null; ResultSet result=null;
    try{ 
      stmt=conn.createStatement();
      result=stmt.executeQuery("SELECT * FROM category");
      while( result.next() ){
        Category category=new Category();
        category.setName(result.getString("name"));
        category.setText(result.getString("text"));
        list.add(category);
      }
    }finally{
      try{ result.close(); }catch(Exception e){ }
      try{ stmt.close(); }catch(Exception e){ }
    }
    System.out.println(list); 
    conn.close();
  }  
}
