package ij.example.shape;

public class Circle extends Shape{
  protected double r;
  public double getR(){ return r; }
  public void setR(double r){ this.r=r; area=INVALID_AREA; }

  public Circle(double r){ this.r=r; }
  public Circle(){ this(0); }

  protected static final double INVALID_AREA = -1;
  protected double area = INVALID_AREA;
  public double getArea(){ 
    if(area==INVALID_AREA){ area=r*r*Math.PI;    }
    return area; 
  } 
  public void setArea(double area){ 
    this.area=area; r=Math.sqrt(area/Math.PI); 
  }
  public void magnify(double m){ setR(r*m); }
  
  public String toString(){ return "Circle ("+r+")"; }

  public static void main(String args[]) {
    Circle c1=new Circle(2);
    System.out.println(c1.getR()+": "+c1.getArea());  
    Circle c2=new Circle(3);
    System.out.println(c2.getR()+": "+c2.getArea());  
    Circle c3=new Circle(); c3.setArea(4);
    System.out.println(c3.getR()+": "+c3.getArea());  
  }
}
