package ij.example.shape;

public class Rectangle extends Shape{
  protected double a;
  public double getA(){ return a; }
  public void setA(double a){ this.a=a; }
  protected double b;
  public double getB(){ return b; }
  public void setB(double b){ this.b=b; }

  public boolean isSquare(){ return a==b; }  
  
  public Rectangle(double a, double b){    
    this.a=a; this.b=b;
  }
  public Rectangle(){ this(0,0); }
  public Rectangle(Rectangle r){ this(r.a,r.b); }
  
  public static Rectangle createSquare(double a){ 
    return new Rectangle(a,a); 
  }
  
  public double getArea(){ return a*b; }
  public void magnify(double mx, double my){ a*=mx; b*=my; }
  public void magnify(double m){ magnify(m,m); } 
  
  public String toString(){ return "Rectangle("+a+"x"+b+")"; }  
  
  public static void main(String args[]) {
    Rectangle r1=new Rectangle(2,3);
    System.out.println(r1.getA()+"x"+r1.getB()+": "+r1.getArea());
    r1.magnify(2,2);
    System.out.println(r1.getA()+"x"+r1.getB()+": "+r1.getArea());
    Rectangle s=Rectangle.createSquare(2);
    System.out.println(s.isSquare());   // true
    s.magnify(2,3);
    System.out.println(s.isSquare());   // false    
  }
}
