package ij.example.shape;

public class Shapes extends Shape {   
  protected static final Shape[] EMPTY_SHAPE_ARRAY=new Shape[0]; 

  protected Shape[] shapes;
  public Shape[] getShapes(){ return shapes; }
  public void setShapes(Shape[] shapes){ 
    this.shapes= (shapes!=null)? shapes :EMPTY_SHAPE_ARRAY;    
  }

  public Shapes(Shape[] shapes){ setShapes(shapes); }        
  public Shapes(){ this(null); }                             
  
  public double getArea(){ double sum=0; 
    for( Shape shape :shapes ){
      sum+=shape.getArea();
    }
    return sum;
  }
  public void magnify(double m){    
    for(Shape shape: shapes){
      shape.magnify(m);
    }
  }
  
  public String toString(){    
    String b="Shapes( "; String sep="";
    for(Shape shape: shapes){
      b+=sep+shape; sep=", ";    
    }
    return b+" )";
  }

  public static void main(String args[]){  
    Shapes s=new Shapes( new Shape[]{
        new Circle(1), new Circle(1), new Rectangle(2,3)  
    });
    System.out.println("Area of "+s+": "+s.getArea());
    s.magnify(2);   
    System.out.println("Area of "+s+": "+s.getArea());
    
    Shape rec=new Shapes(new Shape[]{
        new Rectangle(2,3),
        new Shapes(new Shape[]{
          new Circle(1), new Circle(1), 
        }),
        new Rectangle(2,3)  
      });
      System.out.println("Area of "+rec+": "+rec.getArea());
      rec.magnify(2);   
      System.out.println("Area of "+rec+": "+rec.getArea());
  }
}
