package ij.example.shape;

public class Van extends Shapes{                
  protected static final int CABIN = 0;
  protected static final int DECK = 1;
  protected static final int FRONT_WHEEL = 2;
  protected static final int REAR_WHEEL = 3;

  public Shape getCabin(){ return shapes[CABIN]; }
  public void setCabin(Shape cabin){ shapes[CABIN]=cabin; }
  public Shape getDeck(){ return shapes[DECK]; }
  public void setDeck(Shape deck){ shapes[DECK]=deck; }
  public Shape getFrontWheel(){ return shapes[FRONT_WHEEL]; }
  public void setFrontWheel(Shape frontWheel){ 
    shapes[FRONT_WHEEL]=frontWheel; 
  }
  public Shape getRearWheel(){ return shapes[REAR_WHEEL]; }
  public void setRearWheel(Shape rearWheel){ 
    shapes[REAR_WHEEL]=rearWheel; 
  }

  public Van(Shape cabin, Shape deck, Shape frontWheel, Shape rearWheel){
    super(new Shape[]{cabin,deck,frontWheel,rearWheel});
  }
  public Van(){
    this(
      new EmptyShape(),new EmptyShape(),new EmptyShape(),new EmptyShape()
    );
  }

  public String toString(){
    return "Van( "
      +getCabin()+" ;"+getDeck()+" ;"
      +getFrontWheel()+" ;"+getRearWheel()
      +" )";
  }
  
  public static void main(String args[]){
    Van van=new Van(
              new Rectangle(3,3),new Rectangle(2,10),
              new Circle(2), new Circle(2) 
    );
    System.out.println("Area of "+van+": "+van.getArea());
    van.magnify(2);
    System.out.println("Area of "+van+": "+van.getArea());
    Van van2=new Van(
        new Rectangle(3,3),new Rectangle(2,10),
        new Circle(2), new Circle(2) 
    );
    System.out.println("Area of "+van2+": "+van2.getArea());
    van2.getCabin().magnify(2);   // !
    System.out.println("Area of "+van2+": "+van2.getArea());
  }
}
