package ij.example.simple;

import java.io.*;
import java.util.*;

public class DoubleFile extends AbstractList<Double> implements Closeable{

  protected RandomAccessFile rfile;
  public DoubleFile(File file) throws FileNotFoundException{
    rfile=new RandomAccessFile(file,"rw");
  }

  public void close() throws IOException{ rfile.close(); }

  protected IOException exception;
  public IOException getException(){ return exception; }
  public void setException(IOException exception){ 
    if(this.exception==null) this.exception=exception; 
  }
  public void throwExceptionIfExists() throws IOException{ 
     if(exception!=null){ 
       IOException e=exception; exception=null;
       throw e; 
     }
  }
   
  public int size() {
    try{
      return (int)rfile.length()/8;
    }catch (IOException e){ setException(e);
      return 0;
    } 
  }
  public Double get(int index) {
    try{      
      rfile.seek(index*8);
      return rfile.readDouble();
    }catch(IOException e){ setException(e);     
      return null;
    }
  }


  public static void main(String[] args) throws IOException{
// example data
    DataOutputStream out=
                  new DataOutputStream(new FileOutputStream("data.dat"));    
    for(double d : new double[]{ 7.0, 3.0, 4.0, 2.0, 3.0 }){
      out.writeDouble(d);
    }
    out.close();
//  load
    DoubleFile df= new DoubleFile(new File("data.dat"));
    List<Double> list=new ArrayList<Double>(df);
    System.out.println(list);
// sort
    Collections.sort(list);
    System.out.println(list);
// store
// close
    df.close(); df.throwExceptionIfExists();
  }
}
