package ij.example.words;

import java.util.*;

public class Words implements Iterator<String>, Iterable<String>{
  protected String string;
  protected int index;
  public Words(String string){ this.string=string; }

  public boolean isWordStart(char c){
    return Character.isLetterOrDigit(c) || c=='_';
  }
  public boolean isWordChar(char c){
    return Character.isLetterOrDigit(c) || c=='-' || c=='_';
  }
  public boolean hasNext(){ 
    while(index<string.length() && !isWordStart(string.charAt(index))){       
      ++index;
    }    
    return index<string.length(); 
  }
  public String next(){ int from=index;
    while(index<string.length() && isWordChar(string.charAt(index))){ 
      ++index;
    }
    return string.substring(from,index);    
  }
  public void remove(){ throw new UnsupportedOperationException(); }

  protected boolean iterable=true;
  public Iterator<String> iterator(){ 
    if(iterable){ iterable=false; return this; } 
    throw new IllegalStateException("Repeated call of iterator()");
  }

  public static void main(String args[]){
    Set all=new HashSet();
    for(String word: new Words("to be or not to be")){
      all.add(word);
    }
    System.out.println(all);
  }
}
