package ij.example.words;

import java.util.*;

public class Words implements Iterator<String>{
  protected String string;
  protected int index;
  public Words(String string){ this.string=string; }

  public boolean isWordChar(char c){
    return Character.isLetterOrDigit(c) || c=='-' || c=='_';
  }
  public boolean hasNext(){ 
    while(index<string.length() && !isWordChar(string.charAt(index))){ 
      ++index;
    }    
    return index<string.length(); 
  }
  public String next(){ int from=index;
    while(index<string.length() && isWordChar(string.charAt(index))){ 
      ++index;
    }
    return string.substring(from,index);    
  }
  public void remove(){ throw new UnsupportedOperationException(); }

  public static void main(String args[]){
    for(Iterator<String> wordIt=new Words("to be or not to be");
                                                     wordIt.hasNext(); ){
      String word=wordIt.next();
      System.out.println("'"+word+"'");
    }
  }
}
