package ij.util;

import java.util.*;

public abstract class AbstractKeyBasedMap<K,V> extends AbstractMap<K,V>{
  public abstract Set<K> keySet();  
  public abstract V get(Object key);
  public abstract V put(K key, V value);

  public int size(){ return keySet().size(); }

  protected Set<Map.Entry<K,V>> entrySet;
  public Set<Map.Entry<K,V>> entrySet(){ 
    if(entrySet==null) entrySet=new KeyBasedEntrySet<K,V>(this);
    return entrySet; 
  }
  public AbstractKeyBasedMap(){ }
  public AbstractKeyBasedMap(Map<K,V> map){ putAll(map); }

  public Map<K,V> toMap(){ return this; }
}
