package ij.util;

import java.util.*;

public class ArrayMap<T> extends AbstractMap<T,T>{
  protected T []array;

  public class EntryCursor 
                     implements Iterator<Map.Entry<T,T>>, Map.Entry<T,T>{
    protected int idx=0, current=0;;
    public boolean hasNext(){ return (current=idx)<array.length; }
    public Map.Entry<T,T> next(){ idx+=2; return this; }
    public void remove(){ throw new UnsupportedOperationException(); }            
    public T getKey(){ return array[current]; }
    public T getValue(){ return array[current+1]; }
    public T setValue(T value){ 
      T v=array[current+1]; array[current+1]=value; 
      return v; 
    }
  }  
  public class EntrySet extends AbstractSet<Map.Entry<T,T>> {
    public int size(){ return array.length>>1; }
    public Iterator<Map.Entry<T,T>> iterator(){ 
      return new EntryCursor(); 
    }
  }    
  protected Set entrySet = new EntrySet();
  public Set entrySet(){ 
    if(entrySet==null) entrySet=new EntrySet();
    return entrySet; 
  }
  public int size(){ return array.length>>1; }
       
  public ArrayMap(T... array){ this.array=array; }

  public boolean containsKey(Object key){ 
    for(int i=array.length; (i-=2)>=0; ){
      if(key.equals(array[i])) return true;
    }
    return false;
  } 
  public T get(Object key){ 
    for(int i=array.length; (i-=2)>=0; ){
      if(key.equals(array[i])) return array[i+1];
    }
    return null;
  }
  public T put(T key, T value){ 
    for(int i=array.length; (i-=2)>=0; ){
      if(key.equals(array[i])){ 
        T v=array[i+1]; array[i+1]=value; 
        return v; 
      } 
    }
    return null;
  }    

  public static void main(String args[]){
    System.out.println(
      StringUtil.toString("${error} using '${file}'", new ArrayMap(
        "error", "Write error",
        "file", "log.txt"
      ))
    );
  }
}
