package ij.util;

import ij.example.dvdshop.*;
import java.beans.*;

public class BeanMap {
  protected Object object;
  protected PropertyDescriptor descriptors[];
  public BeanMap(Object object) throws IntrospectionException{ 
    this.object=object;
    descriptors=Introspector.getBeanInfo(object.getClass())
                              .getPropertyDescriptors();
  }
  public Object get(Object name){
    try{
      for(PropertyDescriptor descriptor: descriptors){
        if(name.equals(descriptor.getName())){
          return descriptor.getReadMethod().invoke(object);
        }
      }
    }catch(Exception e){ }
    return null; 
  }
  public static void main(String args[]) throws IntrospectionException{
    DVD dvd=new DVD();
    dvd.setCode("2121");
    dvd.setTitle("Nights on Java"); dvd.setReleaseDate(2006);    
    dvd.setDirector("Ben Boss");
    dvd.setActors("Dev E. Lopez, T. Esther Works");

    BeanMap b=new BeanMap(dvd);
    System.out.println( b.get("title") );
  }
}
