package ij.util;

import ij.example.dvdshop.DVD;

import java.beans.*;
import java.util.LinkedHashSet;
import java.util.Set;

public class BeanMap extends AbstractKeyBasedMap<String,Object>{
  protected Object object;
  protected PropertyDescriptor descriptors[];
  protected Set<String> keys=new LinkedHashSet();
  public Set<String> keySet(){ return keys; }
  public BeanMap(Object object) throws IntrospectionException{ 
    this.object=object;
    descriptors=Introspector.getBeanInfo(object.getClass())
                              .getPropertyDescriptors();
    for(PropertyDescriptor descriptor: descriptors){
      keys.add(descriptor.getName());
    }   
  }

  public Object get(Object name){
    try{
      for(PropertyDescriptor descriptor: descriptors){
        if(name.equals(descriptor.getName())){
          return descriptor.getReadMethod().invoke(object);
        }
      }
    }catch(Exception e){ }
    return null; 
  }
  public Object put(String name, Object value){
    try{
      for(PropertyDescriptor d: descriptors){
        if(name.equals(d.getName())){
          if(d.getPropertyType()!=String.class 
                                             && value instanceof String){
            PropertyEditor pe=PropertyEditorManager
                                        .findEditor(d.getPropertyType());
            if(pe!=null){
              try{
                pe.setAsText((String)value);
                return d.getWriteMethod().invoke(object,pe.getValue());
              }catch(Exception e){ }
            }
          }
          return d.getWriteMethod().invoke(object,value);
        }
      }
    }catch(Exception e){}
    return null; 
  }
  
  public static void main(String args[]) throws IntrospectionException{
    DVD dvd=new DVD();
    dvd.setCode("2121");
    dvd.setTitle("Nights on Java"); dvd.setReleaseDate(2006);    
    dvd.setDirector("Ben Boss");
    dvd.setActors("Dev E. Lopez, T. Esther Works");

    BeanMap b=new BeanMap(dvd);
    System.out.println( b.get("title") );
    
    b.put("title","Nights with JavaBeans");
    System.out.println( b );
    
  }
}
