package ij.util;

import java.io.*;
import java.util.*;

public class CSVReader{
  public static int readValue(StringBuilder b, String ln, int i, 
                                                             String sep){
    if(i>=ln.length()) return -1;
    int p=i; b.setLength(0);
    if(ln.startsWith("\"",i)){ p=++i;
      for( ; (i=ln.indexOf("\"",i))!=-1; ++i){ 
        if(ln.startsWith("\"",i+1)){ 
          b.append(ln,p,i);
          p=++i; 
        }else{ break;         
        }
      }
      if(i==-1) i=ln.length();
      b.append(ln,p,i);
      if(ln.startsWith("\"",i)) ++i;
    }else{ 
      if( (i=ln.indexOf(sep,i))==-1 ){ i=ln.length(); }
      b.append(ln,p,i);
    }    
    if(ln.startsWith(sep,i)) ++i;
    return i;
  }
  public static List readValues(List keys, String ln, String sep){
    StringBuilder b=new StringBuilder();
    int index=0; 
    for( ; ;){
      if((index=readValue(b,ln,index,sep))==-1 ) break;
      keys.add(b.toString());
    }
    return keys;
  }  
  public static Map readValues(Map map, Iterable keys, String ln, String sep){
    StringBuilder b=new StringBuilder();
    int index=0; 
    for(Object key: keys){
      if( (index=readValue(b,ln,index,sep))==-1 ) break;
      map.put(key,b.toString());
    }
    return map;
  }
  
  public static void main(String args[])throws IOException{
    BufferedReader in=new BufferedReader(new FileReader("movie.csv"));
    String ln; List keys=null;
    if((ln=in.readLine())!=null ){
      keys=readValues(new ArrayList(),ln,";");
    }
    while( (ln=in.readLine())!=null ){      
      System.out.println(readValues(new LinkedHashMap(),keys,ln,";"));
    }
    in.close();
  }
}
