package ij.util;

import ij.example.dvdshop.DVD;
import ij.example.dvdshop.DVDShop;

import java.io.*;
import java.util.*;

public class CSVReader implements Iterator<Map>{

  public static int readValue(StringBuilder b, String ln, int i, 
                                                             String sep){
    if(i>=ln.length()) return -1;
    int p=i; b.setLength(0);
    if(ln.startsWith("\"",i)){ p=++i;
      for( ; (i=ln.indexOf("\"",i))!=-1; ++i){ 
        if(ln.startsWith("\"",i+1)){ 
          b.append(ln,p,i);
          p=++i; 
        }else{ break;         
        }
      }
      if(i==-1) i=ln.length();
      b.append(ln,p,i);
      if(ln.startsWith("\"",i)) ++i;
    }else{ 
      if( (i=ln.indexOf(sep,i))==-1 ){ i=ln.length(); }
      b.append(ln,p,i);
    }    
    if(ln.startsWith(sep,i)) ++i;
    return i;
  }
  public static List readValues(List keys, String ln, String sep){
    StringBuilder b=new StringBuilder();
    int index=0; 
    for( ; ;){
      if((index=readValue(b,ln,index,sep))==-1 ) break;
      keys.add(b.toString());
    }
    return keys;
  }  
  public static Map readValues(Map map, Iterable keys, String ln, String sep){
    StringBuilder b=new StringBuilder();
    int index=0; 
    for(Object key: keys){
      if( (index=readValue(b,ln,index,sep))==-1 ) break;
      map.put(key,b.toString());
    }
    return map;
  }
  
  protected BufferedReader in;
  protected Iterable keys;
  protected String ln;
  protected IOException exception;
  public void throwExceptionIfExists() throws IOException{
    IOException e=exception; exception=null;
    if(e!=null) throw e;
  }
  protected void readLine(){ 
    ln=null; 
    try{ 
      if((ln=in.readLine())==null){
        in.close(); 
      }
    }catch(IOException e){ 
      if(exception==null) exception=e;
    }
  }
  
  public CSVReader(BufferedReader in, Iterable keys){ 
    this.in=in; 
    readLine();
    if(keys==null && ln!=null){
      keys=readValues(new ArrayList(),ln,";");
      readLine();
    }
    this.keys=keys;
  }
  public CSVReader(BufferedReader in) { this(in,null); }
  
  public boolean hasNext(){ return ln!=null; }
  public Map next(){ 
    Map map=readValues(new LinkedHashMap(),keys,ln,";"); 
    readLine();
    return map;    
  }
  public void remove(){ throw new UnsupportedOperationException(); }

  public static void main(String args[])throws IOException{
    DVDShop shop=new DVDShop();
    Iterator<Map> i=
        new CSVReader(
          new BufferedReader(new FileReader("movie.csv"))
        );
    while( i.hasNext() ){
      DVD d=new DVD(); d.putAll( i.next() );
      shop.add(d);
    }
    System.out.println(XMLBuilder.toXML(shop));
  }
}
