package ij.util;

import ij.example.dvdshop.DVD;
import ij.example.dvdshop.DVDShop;

import java.io.*;
import java.util.*;

public class CSVWriter {
  public static void writeCSV(Appendable out, Collection<? extends Map> data, Collection<? extends Object> keys) throws IOException{
    for(Map map: data){ String sep="";
      if(keys==null) keys=map.keySet(); 
      for(Object key: keys){ Object value=map.get(key);
        out.append(sep).append( value!=null ? value.toString() :"");
        sep=";";
      }
      out.append('\n');
    }
  }


  public static void main(String[] args) throws IOException{
    DVDShop shop=new DVDShop(); DVD dvd;
    shop.add(dvd=new DVD("1001", "Nights on Java", 2006, "Ben Boss",
               "Dev E. Lopez, T. Esther Works"));
    dvd.setBorrowed(true); dvd.setPrice(2000);
    shop.add(dvd=new DVD("1010", "Matrix",1999,"Watchowsky bros.",
               "Keanu Reeves, Laurence Fishburne, Carrie-Anne Moss" ));
    dvd.setBorrowed(true);
    // tovbbi DVD adatok

    Writer csv=new PrintWriter("movie.csv");
    writeCSV(csv,shop.getDVDs(), null);
    csv.close();
  }
}
