package ij.util;

import ij.example.dvdshop.DVD;
import ij.example.dvdshop.DVDShop;

import java.io.*;
import java.util.*;

public class CSVWriter {
  public static void writeValue(Appendable out, Object value) throws IOException{
    if(value!=null){ String string=value.toString();
      out.append('"');    
      int i=0;
      for(int j; (j=string.indexOf('"',i))!=-1; i=j+1){
        out.append(string,i,j); out.append('"'); out.append('"'); 
      }
      if(i<string.length()) out.append(string,i,string.length());
      out.append('"');          
    }
  }
  
  public static void writeCSV(Appendable out, Iterable<? extends Map> data, Iterable<? extends Object> keys) throws IOException{
    boolean first=true; String sep;
    for(Map map: data){ 
      if(first){ first=false; 
        if(keys==null) keys=map.keySet();
        sep=""; 
        for(Object key :keys){
          out.append(sep); writeValue(out,key); sep=";";
        }
        out.append('\n');
      }
      sep=""; 
      for(Object key :keys){
        out.append(sep); writeValue(out,map.get(key)); sep=";";
      }
      out.append('\n'); 
    }
  }
  public static void writeCSV(Appendable out, Iterable<? extends Map> data) throws IOException{
    writeCSV(out,data,null);
  }

  public static void main(String[] args) throws IOException{
    DVDShop shop=new DVDShop(); DVD dvd;
    shop.add(dvd=new DVD("1001", "Nights on Java", 2006, "Ben Boss",
               "Dev E. Lopez, T. Esther Works"));
    dvd.setBorrowed(true); dvd.setPrice(2000);
    shop.add(dvd=new DVD("1010", "Matrix",1999,"Watchowsky bros.",
               "Keanu Reeves, Laurence Fishburne, Carrie-Anne Moss" ));
    dvd.setBorrowed(true);
    // tovbbi DVD adatok

    Writer csv=new PrintWriter("movie.csv");
    writeCSV(csv,shop.getDVDs());
    csv.close();
  }
}
