package ij.util;

import ij.example.dvdshop.DVD;
import ij.example.dvdshop.DVDShop;

import java.io.*;
import java.util.*;

public class CSVWriter {
  public static void writeValue(Appendable out, Object value) throws IOException{
    if(value!=null){ String string=value.toString();
      out.append('"');
      out.append(string);  
      out.append('"');
    }
  }
  
  public static void writeCSV(Appendable out, Collection<? extends Map> data, Collection<? extends Object> keys) throws IOException{
    for(Map map: data){ 
      if(keys==null) keys=map.keySet(); 
      String sep="";      
      for(Object key: keys){ 
        out.append(sep); writeValue(out, map.get(key)); sep=";";
      }
      out.append('\n');
    }
  }
  public static void writeCSV(Appendable out, Collection<? extends Map> data) throws IOException{
    writeCSV(out,data,null);
  }

  public static void main(String[] args) throws IOException{
    DVDShop shop=new DVDShop(); DVD dvd;
    shop.add(dvd=new DVD("1001", "Nights on Java", 2006, "Ben Boss",
               "Dev E. Lopez, T. Esther Works"));
    dvd.setBorrowed(true); dvd.setPrice(2000);
    shop.add(dvd=new DVD("1010", "Matrix",1999,"Watchowsky bros.",
               "Keanu Reeves, Laurence Fishburne, Carrie-Anne Moss" ));
    dvd.setBorrowed(true);
    // tovbbi DVD adatok

    Writer csv=new PrintWriter("movie.csv");
    writeCSV(csv,shop.getDVDs());
    csv.close();
  }
}
