package ij.util;

import java.sql.*;
import java.util.LinkedHashMap;
import java.util.Map;

public class DBUtil{
  public static void update(Connection conn, String stmt) throws SQLException{
    conn.createStatement().executeUpdate(stmt); 
  }  
  public static void init(Connection conn){
    try{
      update(conn, "CREATE TABLE  category ("
        +"  name varchar(20) NOT NULL default '' PRIMARY KEY,"
        +"  text varchar(40) NOT NULL default ''"
        +")"
      );
      update(conn, "INSERT INTO category (name,text)"
        +" VALUES ('movie','Film, DVD, VHS')" );
      update(conn, "INSERT INTO category (name,text)"
        +" VALUES ('book', 'Knyv')" );
      update(conn, "INSERT INTO category (name,text)"
        +" VALUES ('music','Zene')" );
      update(conn, "INSERT INTO category (name,text)"
        +" VALUES ('phone','Telefon')" );
      
      update(conn, "CREATE TABLE  product ("
          +"  id INTEGER NOT NULL PRIMARY KEY,"
          +"  category VARCHAR(20),"
          +"  name VARCHAR(40),"
          +"  text VARCHAR(200),"
          +"  originalPrice DECIMAL(10),"
          +"  price DECIMAL(10)"
          +")"
      );
      update(conn, "INSERT INTO product (id,category,name,text,originalPrice,price)"
          +" VALUES (1, 'movie', 'Matrix-1-2-3', 'J film, j minsgben', 5000, 6000)" );
      update(conn, "INSERT INTO product (id,category,name,text,originalPrice,price)"
          +" VALUES (2, 'movie', 'Nights on Java', 'Felejthetetlen lmny', 800, 1000)" );
      update(conn, "INSERT INTO product (id,category,name,text,originalPrice,price)"
          +" VALUES (3, 'book', 'XML everywhere', 'Kellemes esti olvasmny', 1800, 1850)" );      
    }catch(SQLException e){ System.err.println(e); 
    }
  }
  
  public static Map<String,Object> toMap(ResultSet result) throws SQLException{
    Map<String,Object> map=new LinkedHashMap<String,Object>(); 
    int count=result.getMetaData().getColumnCount();
    for(int i=1; i<=count; ++i){                          
      map.put(
          result.getMetaData().getColumnName(i), 
          result.getObject(i)
      );
    }
    return map;
  }  
  
  public static void main(String args[]) 
                             throws ClassNotFoundException, SQLException{
    Class.forName("org.apache.derby.jdbc.EmbeddedDriver");
    Connection conn=DriverManager.getConnection(
      "jdbc:derby:forsale_db;create=true", "forsale", "passw"
    );
    init(conn);
    for(Map<String,Object> category: 
      new ResultSetIterator(
        conn.prepareStatement("SELECT * FROM category")
      )
    ){
      System.out.println(category);
    }
    conn.close();
  }
}
