package ij.util;

import java.io.File;
import java.io.IOException;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.*;

public class DomUtil{
  public static Appendable getTextContent(Appendable b, Node node){
    NodeList list = node.getChildNodes();
    L:for(int i=0; i < list.getLength(); i++){ Node item=list.item(i);
        switch( item.getNodeType() ){
          case Node.TEXT_NODE:
          case Node.CDATA_SECTION_NODE: 
            try{ b.append(item.getNodeValue()); 
            }catch(IOException e){ assert false :e;
            }             
            break;
          case Node.ENTITY_REFERENCE_NODE:
            getTextContent(b,item);
            break;
          default:
            break L;
        }
    }
    return b;
  }
  public static String getTextContent(Node node){
    if(!node.hasChildNodes()) return "";
    return getTextContent(new StringBuilder(),node).toString();
  } 
  
  public static Element firstElementOf(Node node, String name){
    NodeList list=node.getChildNodes();
    for( int i=0; i< list.getLength(); ++i){ 
      if( list.item(i).getNodeType()==Node.ELEMENT_NODE 
            && ( name==null || name.equals(list.item(i).getNodeName()) )
      ){
        return (Element)list.item(i);
      }
    }
    return null;    
  }
  public static Element firstElementOf(Node node){
    return firstElementOf(node,null);
  }
  
  public static void conversion(Document dom) throws Exception{
    Element shop=dom.getDocumentElement(); 
    for(Element dvd: new ElementIterator(shop,"DVD")){
      Element code=DomUtil.firstElementOf(dvd,"code");        
      dvd.setAttribute("code",getTextContent(code));
      dvd.removeChild(code);          
    }
  }
  
  public static void main(String args[]) throws Exception{
    DocumentBuilderFactory factory=DocumentBuilderFactory.newInstance();
    Document dom=factory.newDocumentBuilder().parse("dvd.xml");
    conversion(dom);
    Transformer tr=TransformerFactory.newInstance().newTransformer();
    tr.transform(
      new DOMSource(dom),
      new StreamResult(new File("dvd.new.xml"))
    );
    
  }
}  
