package ij.util;

import java.util.*;
import org.w3c.dom.*;

public class ElementIterator implements Iterator<Element>, Iterable<Element>{
  protected NodeList list;
  protected int i=-1;
  protected String name;
  protected boolean skip=true;
  protected Element current;  
  public ElementIterator(NodeList list, String name){
    this.list=list; this.name=name;
    check();
  }
  public ElementIterator(Node node, String name){            
    this(node.getChildNodes(),name);
  }
  public ElementIterator(Node node){                        
    this(node,null); 
  }
  public void check(){
    if(skip){ skip=false;
      while( ++i< list.getLength() ){ 
        if( list.item(i).getNodeType()==Node.ELEMENT_NODE 
         && ( name==null || name.equals(list.item(i).getNodeName()) ) 
        ){
          current=(Element)list.item(i);           
          break;
        }
      }
    }    
  }
  public boolean hasNext(){ check(); return i<list.getLength();}
  public Element next(){ check(); skip=true; return current; }
  public void remove(){ throw new UnsupportedOperationException(); } 

  public Iterator<Element> iterator(){ return this; }        
}

