package ij.util;

import java.io.File;
import java.io.FileFilter;
import java.util.ArrayList;
import java.util.List;

public class IOUtil{  
  public static final int ALL=0, FILES_ONLY=1, DIRECTORIES_ONLY=2;

  public static List<File> listFiles(List<File> list, File file, 
                                            int mode, FileFilter filter){    
    if(file.isDirectory()){
      if( (mode&FILES_ONLY)==0){ list.add(file); } 
      File[] files=file.listFiles();
      if(files!=null){
        for(File f: files){
          listFiles(list,f,mode, filter); 
        }
      }
    }else{
      if( (mode&DIRECTORIES_ONLY)==0 
          &&(filter==null || filter.accept(file))){
        list.add(file);
      }
    }
    return list;
  }  
  public static List<File> listFiles(List<File> list, File file, 
                                                      FileFilter filter){ 
    return listFiles(list,file,ALL,filter);
  }   
  public static List<File> listFiles(File file, int mode, 
                                                      FileFilter filter){ 
    return listFiles(new ArrayList<File>(),file,mode,filter);
  }   

  public static List<File> listFiles(List<File> list, File file){ 
    return listFiles(list,file,null);
  }
  public static List<File> listFiles(File file, FileFilter filter){ 
    return listFiles(new ArrayList<File>(),file,filter);
  }
  public static List<File> listFiles(File file){ 
    return listFiles(file,null);
  }

  public static void main(String args[]){
    System.out.println(listFiles(new File(".")) );
    System.out.println( listFiles(new File(".").getAbsoluteFile()) );
    System.out.println( listFiles(new File("."), FILES_ONLY, 
      new FileFilter(){
        public boolean accept(File f){
          return f.getName().endsWith(".java");      
        }
      }) 
    );
  }
}

