package ij.util;

import java.util.*;

public class KeyBasedEntryCursor<K,V> 
                     implements Iterator<Map.Entry<K,V>>, Map.Entry<K,V>{
  protected Iterator<K> keyIterator;
  protected Map<K,V> map;
  protected K key;
  public K getKey(){ return key; }
  public V getValue(){ return map.get(key); }
  public V setValue(V value){ return map.put(key,value); }
  public KeyBasedEntryCursor(Iterator<K> keys, Map<K,V> map){
    this.keyIterator=keys; this.map=map; 
  }
  public boolean hasNext(){ return keyIterator.hasNext(); }
  public Map.Entry<K,V> next(){ key=keyIterator.next(); return this; }
  public void remove(){ keyIterator.remove(); }
}
