package ij.util;

import java.util.*;

public class KeyBasedEntrySet<K,V> extends AbstractSet<Map.Entry<K,V>>{
  protected Map map;
  protected Set<K> keys;

  public KeyBasedEntrySet(Set<K> keys, Map<K,V> map){
    this.keys=keys; this.map=map;
  }
  public KeyBasedEntrySet(Map<K,V> map){ this(map.keySet(),map); }

  public Iterator<Map.Entry<K,V>> iterator(){ 
    return new KeyBasedEntryCursor(keys.iterator(),map); 
  }
  public int size(){ return map.keySet().size(); }
}
