package ij.util;

import java.lang.reflect.InvocationTargetException;
import java.util.Map;

public class ReflectionUtil{
  public static Map<Class,Class> PRIMITIVES=new ArrayMap<Class>(
      Boolean.class, boolean.class,
      Byte.class, byte.class,
      Short.class, short.class,
      Character.class, char.class,
      Integer.class, int.class,
      Long.class, long.class,
      Float.class, float.class,
      Double.class, double.class
  );
  
  public static String getMethodNameFor(String string){
    return "get"
      +Character.toUpperCase(string.charAt(0))+string.substring(1);
  }
  public static String setMethodNameFor(String string){
    return "set"
      +Character.toUpperCase(string.charAt(0))+string.substring(1);
  }
  
  public static Object get(Object object, String key){    
    try{
      return object.getClass()
        .getMethod(getMethodNameFor(key.toString()))
        .invoke(object);
    }catch(Exception e){ Throwable ex=e;
      if(e instanceof InvocationTargetException){ ex=e.getCause(); }
      if(ex instanceof RuntimeException){ throw (RuntimeException)ex; }
      throw new RuntimeException(ex);
    }
  } 
  public static Object put(Object object, String key, Object value){
    Class theClass=value.getClass();
    Throwable ex=null;
    try{
      return object.getClass()
        .getMethod(ReflectionUtil.setMethodNameFor(key),theClass)
        .invoke(object,value);
    }catch(Exception e){ ex=e; 
    }
    if( (theClass=PRIMITIVES.get(theClass))!=null ){
      try{
        return object.getClass()
          .getMethod(ReflectionUtil.setMethodNameFor(key),theClass)
          .invoke(object,value);
      }catch(Exception e){ ex=e; 
      }
    }
    if(ex instanceof InvocationTargetException){ ex=ex.getCause(); }
    if(ex instanceof RuntimeException){ throw (RuntimeException)ex; }
    throw new RuntimeException(ex);
  }


}
