package ij.util;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Map;

public class ReflectionUtil{
  public static Map<Class,Class> PRIMITIVES=new ArrayMap<Class>(
      Boolean.class, boolean.class,
      Byte.class, byte.class,
      Short.class, short.class,
      Character.class, char.class,
      Integer.class, int.class,
      Long.class, long.class,
      Float.class, float.class,
      Double.class, double.class
  );
  
  public static String getMethodNameFor(String string){
    return "get"
      +Character.toUpperCase(string.charAt(0))+string.substring(1);
  }
  public static String setMethodNameFor(String string){
    return "set"
      +Character.toUpperCase(string.charAt(0))+string.substring(1);
  }
  
  public static Object get(Object object, String key){    
    try{
      return object.getClass()
        .getMethod(getMethodNameFor(key.toString()))
        .invoke(object);
    }catch(Exception e){ Throwable ex=e;
      if(e instanceof InvocationTargetException){ ex=e.getCause(); }
      if(ex instanceof RuntimeException){ throw (RuntimeException)ex; }
      throw new RuntimeException(ex);
    }
  } 
  public static Object put(Object object, String key, Object value){
    String methodName=ReflectionUtil.setMethodNameFor(key);
    Throwable ex=null;
    try{
      if(value!=null){    
        Class theClass=value.getClass();
        try{
          return object.getClass()
            .getMethod(ReflectionUtil.setMethodNameFor(key),theClass)
            .invoke(object,value);
        }catch(Exception e){ ex=e; 
        }
        if( (theClass=PRIMITIVES.get(theClass))!=null ){
          return object.getClass()
            .getMethod(ReflectionUtil.setMethodNameFor(key),theClass)
            .invoke(object,value);
        }
      }else{
        Class parameterTypes[];
        for(Method method :object.getClass().getMethods()){
          if(methodName.equals(method.getName())
            && (parameterTypes=method.getParameterTypes()).length==1
            && !parameterTypes[0].isPrimitive()
          ){
            return method.invoke(object,value);
          }
        }
        throw new NoSuchMethodException(
                             object.getClass().getName()+"."+methodName);
      }
    }catch(Exception e){ ex=e; 
    }    
    if(ex instanceof InvocationTargetException){ ex=ex.getCause(); }
    if(ex instanceof RuntimeException){ throw (RuntimeException)ex; }
    throw new RuntimeException(ex);
  }


}
