package ij.util;

import java.sql.*;
import java.util.*;

public class ResultSetIterator implements Iterator<Map<String,Object>>, Iterable<Map<String,Object>> {
  protected ResultSet result;
  protected boolean hasNext;
  protected boolean skip=true;
  protected SQLException exception;
  protected void setException(SQLException e){
    if(exception==null) exception=e;
  }
  public void throwExceptionIfExists() throws SQLException{
    SQLException e=exception; exception=null;
    if(e!=null) throw e;
  }
  public ResultSetIterator(ResultSet result){
    this.result=result; 
    check();
  }
  public ResultSetIterator(PreparedStatement stmt) throws SQLException{
    this(stmt.executeQuery()); 
  }
  
  public void check(){
    if(skip){ skip=false; 
      try{ hasNext=result.next();
      }catch(SQLException e){ hasNext=false; setException(e); 
      }
      if(!hasNext){
        Statement stmt=null;
        try{ stmt=result.getStatement(); }catch(Exception e){ }
        try{ result.close(); }catch(Exception e){ }
        try{ stmt.close(); }catch(Exception e){ }
      }
    }
  }

  public boolean hasNext(){ check(); return hasNext; }
  public Map<String,Object> next(){ check(); skip=true; 
    try{ return DBUtil.toMap(result); 
    }catch(SQLException e){ setException(e); 
      return Collections.EMPTY_MAP;
    }
  }
  public void remove(){ throw new UnsupportedOperationException(); } 
  
  public Iterator<Map<String,Object>> iterator(){ return this; } 
}
