package ij.util;

import java.util.*;

public class SortedList<T extends Comparable<? super T>> 
                                                    extends ArrayList<T>{
  protected boolean dirty,sorting;
  public void add(int i, T o){ dirty=true; super.add(i,o);  }
  public boolean add(T o){ dirty=true; return super.add(o); }
  public T set(int i, T o){ dirty=!sorting; return super.set(i,o);  }
  public boolean addAll(Collection<? extends T> o){ 
    dirty=true; 
    return super.addAll(o); 
  }
  protected void check(){
    if(dirty){ dirty=false; 
    sorting=true; Collections.sort(this); sorting=false; }
  }
  public T get(int i){ check(); return super.get(i); }
  public Iterator<T> iterator(){ check(); return super.iterator(); }
  
  public static void main(String args[]){
    List<String> l=new SortedList<String>();
    l.addAll(Arrays.asList("x","b","a","q"));
    System.out.println(l);
  }
}
