package ij.util;

import java.util.Arrays;

public class StringUtil {                                            
  public static int count(String string, char ch){ int n=0;
    for(int i=0,j; (j=string.indexOf(ch,i))!=-1; i=j+1){ 
      ++n;
    }
    return n;
  }
  public static String[] split(String string, char sep){ 
    String result[]=new String[count(string,sep)+1]; 
    int index=0; int i=0;
    for(int j; (j=string.indexOf(sep,i))!=-1; i=j+1){       
      result[index++]=string.substring(i,j);
    }
    result[index]=string.substring(i);    
    return result;
  }
  
  public static String join(Object[] array, String separator){ 
    StringBuilder b=new StringBuilder(); String sep="";
    for(Object s: array){ b.append(sep).append(s); sep=separator; }
    return b.toString();
  }
  
  public static String replace(String string, String old, String newStr){ 
    StringBuilder b=null; int p=0;
    for(int i; (i=string.indexOf(old,p))!=-1; p=i+old.length()){
      if( b==null ) b=new StringBuilder();
      b.append(string,p,i).append(newStr);                           
    }         
    return b!=null 
             ? b.append(string,p,string.length()).toString() 
             : string;                 
  } 
  public static String transform(String string, String[] pairs){ 
    for(int i=0; i<pairs.length; i+=2){
      string=replace(string, pairs[i], pairs[i+1]);
    }
    return string;
  } 

  public static void main(String[] args){
    System.out.println( count("a.bb.c",'.') );
    System.out.println( Arrays.toString( split("a.bb.c",'.') ) );
    
    System.out.println( join( split("a.bb.c",'.'), "/") );
    System.out.println( join( split("a.bb.c",'.'), ", ") );
    
    System.out.println( transform("Romeo & Juliette", new String[]{
        "&", "&amp;",
        "<", "&lt;",
        ">", "&gt;",
    }));
    System.out.println( transform("/-.-. --.-/-.-. --.-/-.. ./", 
        new String[]{
          "/",      " ~ ",
          " -.-. ",  " c ",
          " -.. ",   " d ",
          " . ",     " e ",
          " --.- ",  " q ",
          " ",      "",
          "~",      " ",
    }));
  }
}
