package ij.util;

import java.util.*;

public class StringUtil {                                            
  public static int count(String string, char ch){ int n=0;
    for(int i=0,j; (j=string.indexOf(ch,i))!=-1; i=j+1){ 
      ++n;
    }
    return n;
  }
  public static String[] split(String string, char sep){ 
    String result[]=new String[count(string,sep)+1]; 
    int index=0; int i=0;
    for(int j; (j=string.indexOf(sep,i))!=-1; i=j+1){       
      result[index++]=string.substring(i,j);
    }
    result[index]=string.substring(i);    
    assert join(result,Character.toString(sep)).equals(string);
    return result;
  }
  public static List<String> splitToList(String string, char sep){ 
    List<String> list=new ArrayList<String>(); int i=0;
    for(int j; (j=string.indexOf(sep,i))!=-1; i=j+1){       
        list.add( string.substring(i,j) );
    }
    list.add(string.substring(i));    
    return list;
  }
  
  public static String join(Object[] array, String separator){ 
    StringBuilder b=new StringBuilder(); String sep="";
    for(Object s: array){ b.append(sep).append(s); sep=separator; }
    return b.toString();
  }
  public static String join(List list, String separator){ 
    StringBuilder b=new StringBuilder(); String sep="";
    for(Object s: list){ b.append(sep).append(s); sep=separator; }
    return b.toString();
  }
  
  public static String replace(String string, String old, String newStr){ 
    StringBuilder b=null; int p=0;
    for(int i; (i=string.indexOf(old,p))!=-1; p=i+old.length()){
      if( b==null ) b=new StringBuilder();
      b.append(string,p,i).append(newStr);                           
    }         
    return b!=null 
             ? b.append(string,p,string.length()).toString() 
             : string;                 
  } 
  public static String transform(String string, String[] pairs){ 
    for(int i=0; i<pairs.length; i+=2){
      string=replace(string, pairs[i], pairs[i+1]);
    }
    return string;
  } 
  
  public static String toHTML(String string){ 
    StringBuilder b=null; String s; int p=0;
    for(int i=0, l=string.length(); i<l; ++i){ s=null;
      switch(string.charAt(i)){
        case '&': s="&amp;"; break;
        case '<': s="&lt;"; break;
        case '>': s="&gt;"; break;
      }
      if(s!=null){ if( b==null ) b=new StringBuilder();
        b.append(string,p,i).append(s); p=i+1;               
      }
    }
    return b!=null 
              ? b.append(string,p,string.length()).toString()
              : string;         
  }  

  public static List<String> trim(List<String> list){
    for(int i=0; i<list.size(); ++i){
      list.set(i,list.get(i).trim());
    }
    return list;
  }  
  
  public static String toString(String string, Map op){ 
    if(string.indexOf("${")==-1) return string;
    StringBuilder b=new StringBuilder(string.length()); int p=0;
    for(int start,end; (start=string.indexOf("${",p))!=-1 
                      && (end=string.indexOf("}",start+2))!=-1; p=end+1){
      Object v=op.get(string.substring(start+2,end));
      if(p<start) b.append(string,p,start);
      if(v!=null) b.append(v);
    }
    if(p<string.length()) b.append(string,p,string.length());
    return b.toString();
  }
  
  public static void main(String[] args){
    System.out.println( count("a.bb.c",'.') );
    System.out.println( Arrays.toString( split("a.bb.c",'.') ) );
    
    System.out.println( join( split("a.bb.c",'.'), "/") );
    System.out.println( join( split("a.bb.c",'.'), ", ") );
    
  /*  System.out.println( transform("Romeo & Juliette", new String[]{
        "&", "&amp;",
        "<", "&lt;",
        ">", "&gt;",
    }));
    System.out.println( transform("/-.-. --.-/-.-. --.-/-.. ./", 
        new String[]{
          "/",      " ~ ",
          " -.-. ",  " c ",
          " -.. ",   " d ",
          " . ",     " e ",
          " --.- ",  " q ",
          " ",      "",
          "~",      " ",
    }));
    
    System.out.println( toHTML("Romeo & Juliette") ); */
    
    //System.out.println( join(splitToList("a.bb.c",'.'), "/") );
    //System.out.println( join( Arrays.asList( "xx", "y", "zzz" ),"/" ) );
    
    Map map=new HashMap();
    map.put("error", "Write error");
    map.put("file", "log.txt");
    System.out.println( toString("${error} using '${file}' file", map) );

  }
}
