package ij.util;

import java.io.*;

public class XMLBuilder{

  public static void appendXML(Appendable b, String ident, 
                                                        XMLFragment xml) throws IOException{
    String name=xml.appendXMLHead(b,ident);
    if(name!=null){
      String inner=ident+"  ";
      XMLFragment body[]=xml.appendXMLBody(b,inner);
      if(body!=null){ 
        for(XMLFragment x: body){
          appendXML(b,inner,x);
        }
      }
      b.append(ident).append("</").append(name).append(">\n");
    }
  }
  public static String toXML(XMLFragment xml){
    StringBuilder b=new StringBuilder();
    b.append("<?xml version=\"1.0\" encoding=\"iso-8859-2\"?>\n");
    try{ appendXML(b,"",xml);
    }catch(IOException e){ 
      assert false: "Impossible: StringBuilder.append: "+e; 
    }
    return b.toString();
  }
  
  public static void writeXML(File file, XMLFragment xml) throws IOException{
    Writer out=new BufferedWriter(new FileWriter(file));
    out.append("<?xml version=\"1.0\" encoding=\"iso-8859-2\"?>\n");
    appendXML(out,"",xml);
    out.close();
  }
  
}

