package ij.util;

import java.io.FileInputStream;
import java.io.IOException;

import javax.xml.parsers.*;

import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;

public class XMLReader extends DefaultHandler{
  
  protected StringBuilder text=new StringBuilder();
  protected String textName;

  public void set(String name, CharSequence value) throws SAXException{
    System.out.println(name+"="+value);
  }
  public void startElement(String uri, String localName, String qName,
                              Attributes attributes) throws SAXException{
    if(textName!=null) set(textName,text);
    textName=localName; text.setLength(0);
    System.out.println('<'+localName);
  }
  public void characters(char[] ch, int start, int length) 
                                                     throws SAXException{
    if(textName!=null) text.append(ch,start,length);
  }
  public void endElement(String uri, String localName, String qName) 
                                                     throws SAXException{
    if(textName!=null) set(textName,text);
    textName=null;
    System.out.println('>'+localName);
  }


  
  protected SAXParser getSAXParser() throws SAXException, ParserConfigurationException{
    SAXParserFactory factory = SAXParserFactory.newInstance();
    factory.setNamespaceAware(true); factory.setValidating(false);
    return factory.newSAXParser();
  }
  public void parse(InputSource inputSource) throws SAXException, ParserConfigurationException, IOException{
    getSAXParser().parse( inputSource, this );
  }
  public void parse(String fname, String encoding) throws SAXException, ParserConfigurationException, IOException{
    InputSource inputSource =new InputSource(new FileInputStream(fname));
    if(encoding!=null) inputSource.setEncoding(encoding);
    parse(inputSource);
  }
  public void parse(String fname) throws SAXException, ParserConfigurationException, IOException{
    parse(fname,null);
  }
  
  public static void main(String args[]) throws SAXException, ParserConfigurationException, IOException{
    new XMLReader().parse("dvd.xml");
  }  
  
}
