package ij.util;

import java.util.HashMap;
import java.util.Map;

public class XMLUtil {
  public static void appendXML(StringBuilder b, String ident, 
                                        String element, Object value){     
    if(value!=null){
      b.append(ident).append('<').append(element).append('>');
      b.append(StringUtil.toHTML(value.toString()));
      b.append("</").append(element).append(">\n");
    }
  }  
  
  public static String fromXML(String xml, String element){     
    String start='<'+element+'>', end="</"+element+'>';
    int i,j;
    if( (i=xml.indexOf(start))!=-1 
        && (j=xml.indexOf(end,i+=start.length()))!=-1){
      return xml.substring(i,j);   // !hinyos!
    }else{
      return null;
    }
  }
  
  public static void appendXML(StringBuilder b, String ident, 
                            Map<? extends Object,? extends Object> map){ 
    for(Map.Entry e: map.entrySet()){
      appendXML(b,ident,e.getKey().toString(), e.getValue());
    }
  }  
  public static StringBuilder appendXML(StringBuilder b, String ident, 
                 String name, Map<? extends Object,? extends Object> map){ 
    b.append(ident).append('<'+name+">\n");
    appendXML(b,ident+" ", map);
    b.append(ident).append("</"+name+">\n");
    return b;
  }
  public static String toXML(String name, 
                               Map<? extends Object,? extends Object> map){ 
    StringBuilder b=new StringBuilder();
    b.append("<?xml version=\"1.0\" encoding=\"iso-8859-2\"?>\n");
    appendXML(b,"",name,map);
    return b.toString();
  }
  
  public static void main(String args[]){
    Map map=new HashMap();
    map.put("error", "Write error");
    map.put("file", "log.txt ");
    System.out.println( toXML("message", map) );
  }  
}
